import java.io.StringReader;
import java.net.URL;
import javax.xml.namespace.QName;
import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;
import javax.xml.ws.Dispatch;
import javax.xml.ws.Service;
import javax.xml.ws.soap.SOAPBinding;

public class HelloClientMessage {
    public HelloClientMessage() throws Exception {
        // T[rX̐
        QName serviceName 
            = new QName("http://ws.javainthebox.net/", "HelloService");
        URL wsdlUrl = new URL("http://localhost:8080/hello?wsdl");
        Service service = Service.create(wsdlUrl, serviceName);
//        Service service = Service.create(serviceName);
//        QName portName 
//            = new QName("http://ws.javainthebox.net/", "HelloPort");
//        service.addPort(portName, SOAPBinding.SOAP12HTTP_BINDING,
//                        "http://localhost:8080/hello");
 
        // DispatchIuWFNg̐
        QName portName 
            = new QName("http://ws.javainthebox.net/", "HelloPort");
        Dispatch<Source> dispatch 
            = service.createDispatch(portName,
                                     Source.class,
                                     Service.Mode.PAYLOAD);
 
        // SourceIuWFNg̍쐬
        String request 
            = "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"yes\"?>"
            + "<ns:sayHello xmlns:ns=\"http://ws.javainthebox.net/\">"
            + "<arg0>World</arg0>"
            + "</ns:sayHello>";
        Source requestMessage = new StreamSource(new StringReader(request));

        // Web T[rX̎s
        Source resultMessage = dispatch.invoke(requestMessage);

        // ʂ̏o
        Transformer transformer = TransformerFactory.newInstance().newTransformer(); 
        Result result = new StreamResult(System.out);
        transformer.transform(resultMessage, result);
    }

    public static void main(String[] args) throws Exception {
        new HelloClientMessage();
    }
}
